#include <iostream>

using namespace std;

int curdepth = 0;

class Node {
  char data;
  Node *left;
  Node *right;
  static int maxdepth;
  int mydepth = 0;
  static int outdepth;
  bool iamout = 0;
  static bool lastout;
public:
  Node() : data(0), left(nullptr), right(nullptr) {}
  
  Node(char data) : data(data), left(nullptr), right(nullptr) {}
  
  Node(char data, int depth) : data(data), left(nullptr), right(nullptr), mydepth(depth) {}
  
  void setData(char data) {
    this->data = data;
  }
  
  int getData() const {
    return data;
  }
  
  void insert(char data) {
    curdepth++;
    if (data < this->data) {
      if (left == nullptr) {
        left = new Node(data,curdepth);
        if (curdepth > maxdepth) {
          maxdepth = curdepth;
        }
        curdepth = 0;
      } else {
        left->insert(data);
      }
    } else {
      if (right == nullptr) {
        right = new Node(data);
        if (curdepth > maxdepth) {
          maxdepth = curdepth;
        }
        curdepth = 0;
      } else {
        right->insert(data);
      }
    }
  }
  
  ~Node() {
    if (left != nullptr) {
      delete left;
    }
    if (right != nullptr) {
      delete right;
    }
    cout << "Max depth: " << maxdepth << endl;
  }
  
  void resetout() {
    iamout = 0;
    if (left != nullptr) {
      left->resetout();
    }
    if (right != nullptr) {
      right->resetout();
    }
  }
  
  void display(bool iamrigth=0) const {
    if (outdepth!=mydepth)cout << endl;
    cout << "\033["<<maxdepth-mydepth+1<<"C";
    if (iamrigth) {
        cout<<"\033["<<outdepth<<'A';
        for (int i = 0; i < maxdepth-mydepth-1; i++) {
          cout << ' ';
        }
    }
    cout << data<<std::flush;
    outdepth = mydepth;
    if (left != nullptr) {
      left->display();
      lastout=0;
    }
    if (right != nullptr) {
      right->display(1);
    }
  }
  
  static int getmaxdepth() {
    return maxdepth;
  }
};

int Node::maxdepth = 0;
int Node::outdepth = 0;
bool Node::lastout = 0;

int main() {
  Node *root = nullptr;
  char input;
  while (true) {
    cin >> input;
    if (input == -1) {
      break;
    }
    if (root == nullptr) {
      root = new Node(input);
    } else {
      root->insert(input);
      for (int i = 0; i < Node::getmaxdepth(); i++) {
        cout << "--";
      }
      cout << endl;
      root->display();
    }
  }
  cin >> input;
  root->insert(input);
  delete root;
  return 0;
}
